<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2005 Coppermine Dev Team
  v1.1 originaly written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.8
  $Source: /cvsroot/cpg-contrib/master_template/codebase.php,v $
  $Revision: 1.3 $
  $Author: donnoman $
  $Date: 2005/12/08 05:46:49 $
  ********************************************
  Modified by Frantz for user_pruning plugin
  2007/11/01
  ********************************************
  Modified by Nibbler
  2008/01/29
**********************************************/

require('./include/init.inc.php');
require('plugins/user_pruning/include/init.inc.php');

if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

if($lang_text_dir=='ltr') {
	$align="left";
	$direction="ltr";
}else {
	$align="right";
	$direction="rtl";
}

//functions for this plugin
//search pictures from a specific user
function deluser($user_id)
{
	global $CONFIG,$lang_plugin_user_pruning;
	
	$cat = FIRST_USER_CAT + $user_id;
	
	$indent="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	
	$result = cpg_db_query("SELECT aid, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = $cat");
	
	while ($row = mysql_fetch_assoc($result)){
	
		echo "<tr><td>".$indent.$lang_plugin_user_pruning['alb_del'].$row['title']."</td></tr>";
		
		delalbum($row['aid']);
	}

	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CATEGORIES']} WHERE cid = $cat LIMIT 1");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_USERS']} WHERE user_id = $user_id LIMIT 1");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_COMMENTS']} WHERE author_id = $user_id");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_BANNED']} WHERE user_id = $user_id");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_FAVPICS']} WHERE user_id = $user_id LIMIT 1");
	
}

function delalbum($aid){

	global $CONFIG;
	
	$result = cpg_db_query("SELECT pid FROM {$CONFIG['TABLE_PICTURES']} WHERE aid = $aid");

	while ($row = mysql_fetch_assoc($result)){
		delfile($row['pid']);
	}
	
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid = $aid LIMIT 1");
}

function delfile($pid){

	global $CONFIG;

	$result = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_PICTURES']} WHERE pid = $pid");

	while ($row = mysql_fetch_assoc($result)){
	
		echo "<tr><td>".$indent.$indent.$lang_plugin_user_pruning['pic_del'].$row['filename']."</td></tr>";
		
		$folder = $CONFIG['fullpath'] . $row['filepath'];
		$image = $folder . $row['filename'];
		$normal = $folder . $CONFIG['normal_pfx'] . $row['filename'];
		$thumb = $folder . $CONFIG['thumb_pfx'] . $row['filename'];

		
		if(isset($CONFIG['mini_pfx'])) {
			// modpack compatibility {Stramm}
			$mini = $folder . $CONFIG['mini_pfx'] . $row['filename'];
			$orig = $folder . $CONFIG['orig_pfx'] . $row['filename'];

      	if (file_exists($mini)){
      		$test = unlink($mini);
      	}
      	if (file_exists($orig)){
      		$test = unlink($orig);
      	}
		}

		if (file_exists($normal)){
      	$test = unlink($normal);
      }
      if (file_exists($image)){
      	$test = unlink($image);
      }
      if (file_exists($thumb)){
      	$test = unlink($thumb);
      }
       if (file_exists($folder . '/index.html')){
      	$test = unlink($folder . '/index.html');
      }
      if (is_dir($folder)){
      	$test = rmdir($folder);
      }

		cpg_db_query("DELETE FROM {$CONFIG['TABLE_PICTURES']} WHERE pid = $pid LIMIT 1");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_COMMENTS']} WHERE pid = $pid");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_EXIF']} WHERE filename='".addslashes($image)."' LIMIT 1");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_HIT_STATS']} WHERE pid = $pid");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_VOTES']} WHERE pic_id = $pid");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_VOTE_STATS']} WHERE pid = $pid");
	}
}


//main code
if (isset($_POST['valid'])){
	$valid=isset($_POST['valid']);
}

//display header
pageheader($lang_plugin_user_pruning['display_name']);

starttable('100%', $lang_plugin_user_pruning['display_name'].' - '.$lang_plugin_user_pruning['version'].'    '.'<a href="pluginmgr.php" class="admin_menu">Plugin Manager</a>',2);

if (!isset($valid)){
//display form for enter day number
$dayform=<<<EOT
<form name="daynumber" action="" method="post">
<tr><td align="center" class="tableh2">{$lang_plugin_user_pruning['form_title']}</td></tr>
<tr><td align="center">{$lang_plugin_user_pruning['day_field']}<input type="text" class="textinput" name="day_number" size="5" value="365" />{$lang_plugin_user_pruning['days']}</td></tr>
<tr><td align="center"><input type="submit" name="valid" class="button" value="{$lang_plugin_user_pruning['valid']}" /></td></tr>
</form>
EOT;
echo $dayform;

} else {

	unset($valid);

	$d = (int) $_POST['day_number'];

	// failsafe
	if (!$d || $d == 1)
		die('Invalid number of days');
		
	$result = cpg_db_query("SELECT user_id, user_name, user_lastvisit FROM {$CONFIG['TABLE_USERS']} WHERE user_group <> 1 AND user_lastvisit < NOW() - INTERVAL $d DAY");
	
	while ($row = mysql_fetch_array($result)){
  
  		$last_connect = strtotime($row['user_lastvisit']);

		echo "<tr><td>".$lang_plugin_user_pruning['user'].$row['user_name']."</td></tr>";  
				
		deluser($row['user_id']);
	}

	echo "<tr><td class='button' align='center'><a href='index.php'<input type='submit' class='button' name='return' value='{$lang_plugin_user_pruning['back']}'></a></td></tr>";
}

//end table
endtable();
pagefooter();
